# Navigator

- category: API
- chinese: 导航
- type: API 能力

---

## 设计思路

实现端内的跳转功能，在 Native 端封装了 `navigator` 模块，，在 web 端使用 location.href 完成跳转。

**注意** 端内的跳转表现因客户端而异（ navigator 模块本身在端内可以被任意覆写，不受基础 weex sdk 的约束 ），因此兼容性需要慎重测试。

## API

### Navigator.push(url,title,animate,extraParams)

- url : string, url 地址。url 支持的协议类型需要看客户端上层做了哪些适配，一般常见的有 http:, https:, mailto:, sms:, tel: 等
- title : 下级页面标题，title 能否被设置，因各个 app 实现逻辑不同，此参数并非所有 app 内都有效。
- animate: 是否存在过渡动画，默认 true，因各个 app 实现逻辑不同，此参数并非所有 app 内都有效。
- extraParams: 附加参数, 默认 {target:"\_self"}， 如果 target 设置为 "\_blank", h5 下会在新窗口打开页面。

### Navigator.pop()

返回上级页面，此方法并非所有 app 内都有效

```js
Navigator.push('xxxUrl', '页面标题');
Navigator.pop();
```

## 其他

- bug、建议联系 <a href="dingtalk://dingtalkclient/action/sendmsg?dingtalk_id=kjwo3w5">@翊晨</a>
- 钉钉交流群

<img src="https://img.alicdn.com/tfs/TB101EESpXXXXXFXpXXXXXXXXXX-1122-1362.jpg" width="260" />
